(document:surround "/std/frame")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-control")

(define (make-row cmd)
  (vector (woo-get-option cmd 'name)
          (woo-get-option cmd 'summary)))

(define (write-mode)
  (woo-catch/message
   (thunk
     (woo-write "/control/facility"
		'fname (facilities text)
		'name (modes text)))))

(define (update-help fname current-mode)
  (let ((current-help (woo-get-option
			(woo-read-first (string-append "/control/facility/" current-mode)
					'fname fname)
			'help)))
    (mode-help text current-help)))

(gridbox columns "10;20;40;10"
	 ;;
	 (spacer)
	 (document:id facilities
		      (listbox colspan 2
			       columns 2
			       header (vector (_ "Facility") (_ "Summary"))
			       (when selected
				 (let* ((fname (facilities text))
					(avail-modes (woo-list-names "/control/facility" 'fname fname))
					(current-mode (woo-get-option
							(woo-read-first "/control/facility" 'fname fname)
							'name)))
				   (modes rows avail-modes)
				   (modes current (string-list-index current-mode avail-modes))
				   (update-help fname current-mode)))))
	 (spacer)

	 ;;
	 (spacer)
	 (label "" colspan 2)
	 (spacer)

	 ;;
	 (spacer)
	 (separator colspan 2)
	 (spacer)

	 ;;
	 (spacer)
	 (label (bold (_ "State")))
	 (spacer)
	 (spacer)

	 ;;
         (spacer)
	 (document:id modes
		      (listbox
			(when selected
			  (update-help (facilities text) (modes text)))))
	 (document:id mode-help (textbox ""))
	 (spacer)

	 ;;
	 (spacer)
	 (spacer)
	 (document:id b (button (_ "Apply")
				align "right"
				(when clicked (write-mode))))
	 (spacer))

(document:root (when loaded
		 (woo-catch/message
		   (thunk
		     (facilities rows (map make-row (woo-list "/control"))
				 current 0
				 selected)))))

